unit F_Access;

interface

uses Windows,Messages,Classes,SysUtils,Bde,DbiErrs,DbiProcs,DbiTypes,DB,DBConsts,
     DBTables,ComObj,Dialogs,Forms, Controls,StdCtrls;

  function  GetEngine(var DbEngine: Variant): Boolean;
  procedure ConfigDataBase(var DataBase1: TDataBase; Login: Boolean);
  procedure CreateAccessFields(Table1: TTable; DbDataBase,DbTable: Variant);
  function  AppendTableBde(var TableSource, TableAccess: TTable; OverWrite: Boolean): Integer;
  function  AppendTableDao(var Table1: TTable; // Table source
                           DbAccessName, // Path and name of Table target : 'C:\Tmp\NewTable.Mdb'
                           TbAccessName: String; // Table target name only: 'NewTable'
                           OverWrite: Boolean): Integer; // Overwrite: True o Append: False
  function  CopyToAccess(var Table1: TTable; DbTable: Variant): Integer;
  function  TestAlias(sAlias, sType, sPath : String): Boolean;
  procedure NewTable(var Table1: TTable);
  procedure CreateExampleTable(var Table1: TTable);
  function  QueryBDE(var Query1: TQuery; Alias,SqlFilter: String): Integer;
  function  QueryDao(var DataBase1: TDataBase; var TableSource, TableQuery: TTable;
                     DbAccessName,TbAccessName,SqlFilter: String): Integer;
  function  CompactDataBaseDao(DbAccessName: String): Boolean;
  function  RepairDataBaseDao(DbAccessName: String): Boolean;
  procedure ShowSigecom(Text: String);
  procedure InfoIndex(Table1: TTable; sIndexName: String; var IndexInfo: TComboBox);

const

  // DatabaseTypeEnum constants
  dbVersion10 = $00000001;
  dbEncrypt   = $00000002;
  dbDecrypt   = $00000004;
  dbVersion11 = $00000008;
  dbVersion20 = $00000010;
  dbVersion30 = $00000020;

  // LANGID CollatingOrderEnum constants
  dbSortNeutral = $00000400;
  dbSortArabic = $00000401;
  dbSortCyrillic = $00000419;
  dbSortCzech = $00000405;
  dbSortDutch = $00000413;
  dbSortGeneral = $00000409;
  dbSortGreek = $00000408;
  dbSortHebrew = $0000040D;
  dbSortHungarian = $0000040E;
  dbSortIcelandic = $0000040F;
  dbSortNorwdan = $00000406;
  dbSortPDXIntl = $00000409;
  dbSortPDXNor = $00000406;
  dbSortPDXSwe = $0000041D;
  dbSortPolish = $00000415;
  dbSortSpanish = $0000040A;
  dbSortSwedFin = $0000041D;
  dbSortTurkish = $0000041F;
  dbSortJapanese = $00000411;
  dbSortChineseSimplified = $00000804;
  dbSortChineseTraditional = $00000404;
  dbSortKorean = $00000412;
  dbSortThai = $0000041E;
  dbSortSlovenian = $00000424;
  dbSortUndefined = $FFFFFFFF;

  // DataTypeEnum constants
  dbBoolean = $00000001;
  dbByte = $00000002;
  dbInteger = $00000003;
  dbLong = $00000004;
  dbCurrency = $00000005;
  dbSingle = $00000006;
  dbDouble = $00000007;
  dbDate = $00000008;
  dbBinary = $00000009;
  dbText = $0000000A;
  dbLongBinary = $0000000B;
  dbMemo = $0000000C;
  dbGUID = $0000000F;
  dbBigInt = $00000010;
  dbVarBinary = $00000011;
  dbChar = $00000012;
  dbNumeric = $00000013;
  dbDecimal = $00000014;
  dbFloat = $00000015;
  dbTime = $00000016;
  dbTimeStamp = $00000017;

  // RecordsetTypeEnum constants
  dbOpenTable = $00000001;
  dbOpenDynaset = $00000002;
  dbOpenSnapshot = $00000004;
  dbOpenForwardOnly = $00000008;
  dbOpenDynamic = $00000010;

  dbSeeChanges = $00000200;

  dbPessimistic     = $00000002;
  dbOptimistic      = $00000003;
  dbOptimisticValue = $00000001;
  dbOptimisticBatch = $00000005;

  {Variables for MsAccess DataBase}
  DbLangGeneral = ';LANGID=0x0409;CP=1252;COUNTRY=0';

var
 Dir,sDataBaseName, sTableName, sAlias: String;
 TimeStart: Double;
 Hour,Min,Sec,MSec : Word;  // To measure the time until the miliseconds

implementation

function GetEngine(var DbEngine: Variant): Boolean;
begin
 Result := False;
 try
  DbEngine := CreateOleObject('Dao.DbEngine.35');
 except
  try
   DbEngine := CreateOleObject('Dao.DbEngine');
  except
   ShowMessage('Impossible to initialize DAO' + #13 +
               'The Microsoft DAO should be installed in its machine' + #13 +
               'The product is part of MS Access, Visual Basic 4/5, Ms Office, etc.');
   Screen.Cursor := crDefault;
   Exit;
  end;
 end;
 if VarType(DbEngine) = VarDispatch then Result := True;
end;

procedure ConfigDataBase(var DataBase1: TDataBase; Login: Boolean);
begin
 with DataBase1 do begin
  Close;
  DriverName   := 'MSACCESS';
  AliasName    := sAlias;
  DataBaseName := sAlias;
  LoginPrompt  := Login;
  Temporary    := True;
  Open;
 end;
end;

procedure CreateAccessFields(Table1: TTable; DbDataBase,DbTable: Variant);
var
 bActive, bControl: Boolean;
 i: Integer;
 vField{,vIndex} : Variant;
begin
 with Table1 do begin
  bActive := Active;
  if not Active then Open;
  First;

  vField := DBTable.CreateField('Tmp',dbByte);
  for i := 0 to FieldCount -1 do begin
   bControl := True;
   Case FieldDefs.Items[i].DataType of
    ftString,ftWideString:
               begin
                vField := DbTable.CreateField(FieldDefs.Items[i].Name,dbText,
                                              FieldDefs.Items[i].Size);
                vField.AllowZeroLength := True; // True: It allows the empty field, False for defect
               end;
    ftBytes:   begin
                vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbByte);
                vField.AllowZeroLength := True; // True: It allows the empty field, False for defect
               end;
    ftVarBytes: begin
                 vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbByte);
                 vField.AllowZeroLength := True; // True: It allows the empty field, False for defect
                end;
    ftMemo,
    ftFmtMemo: begin
                vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbMemo);
                vField.AllowZeroLength := True; // True: It allows the empty field, False for defect
               end;
    ftWord,
    ftSmallint: vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbInteger);
    ftInteger,
    ftAutoInc:  vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbLong);
    ftLargeInt: vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbBigInt);
    ftFloat,
    ftBCD:      vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbDouble);
    ftCurrency: vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbCurrency);
    ftBoolean : vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbBoolean);
    ftDate,
    ftDateTime: vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbDate);
    ftTime:     vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbTime);
    ftParadoxOle,
    ftDBaseOle:   vField := DBTable.CreateField(FieldDefs.Items[i].Name,dbLongBinary);
   else
    bControl := False;
   end;
    if bControl then DbTable.Fields.Append(vField);
  end;
  Active := bActive;
 end;

(*
 // Example for create an Index
 //#Ejemplo para crear un indice
 vIndex := DbTable.CreateIndex('Texto');
 vField := DBTable.CreateField('Texto',dbText,10);
 vIndex.Fields.Append(vField);
 // vIndex.Primary := True;
 // vIndex.Unique := True;
 // vIndex.Required := True;
 // vIndex.IgnoreNulls := True;
 DbTable.Indexes.Append(vIndex);
*)

 DbDataBase.TableDefs.Append(DbTable);
end;

function CopyToAccess(var Table1: TTable; DbTable: Variant): Integer;
var
 i,n: Integer;
begin
 Result := 0;

 if VarType(DbTable) <> VarDispatch then begin
  ShowMessage('We are not connected with MsAccess in' + #13 +
              'function CopyToAccess(DbTable)');
  Exit;
 end;

 with Table1 do begin
  if not Active then Open;
  n := 0;
  First;
  while not Eof do begin
   DbTable.AddNew;
   // DbTable.Edit; // For when a record is in Edit mode, the same as in Delphi
   for i := 0 to FieldCount -1 do begin
    if FieldDefs.Items[i].DataType in [ftString, ftBytes, ftVarBytes, ftWideString,
                                       ftBytes,ftVarBytes,ftMemo, ftFmtMemo,ftWideString]
     then if Length(Fields[i].AsString) > 0 then DbTable.Fields[i] := Fields[i].AsString;

    if FieldDefs.Items[i].DataType in [ftSmallint,ftInteger,ftWord,ftLargeInt,
                                       ftFloat,ftCurrency,ftBoolean,ftDate,
                                       ftTime,ftDateTime,ftParadoxOle,ftDBaseOle,
                                       ftAutoInc,ftCursor,ftADT,ftArray,ftReference,
                                       ftDataSet]
     then if Fields[i].Value <> null then DbTable.Fields[i] := Fields[i].Value;
   end;
   DbTable.Update;
   Next;
   Inc(n)
  end;
  Close;
 end;
 Result := n;
end;

function TestAlias(sAlias, sType, sPath : String): Boolean;
var
 Lista       : TStringList;
 i           : Integer;
 fConfigMode : TConfigMode;
 DbEngine,DbAccess,DbTable: Variant;
begin

{Call example:
var
 sPath, sAlias: String;
begin

 sPath := ExtractFilePath(Application.ExeName);
 if sPath[Length(sPath)] <> '\' then sPath := sPath + '\';

 sAlias := 'Customer';

 // dBase
 if not TestAlias(sAlias, 'dBase', sPath) then begin
  ShowMessage('Cannot create the alias ' + sAlias);
  Application.Terminate;
 end;

 // Paradox
 if not TestAlias(sAlias, 'Paradox', sPath) then begin
  ShowMessage('Cannot create the alias ' + sAlias);
  Application.Terminate;
 end;

 // In this case, if not exists the .mdb file, create this with Ms Dao 3.0 or 3.5
 if not TestAlias(sAlias, 'MSACCESS', sPath) then begin
  ShowMessage('Cannot create the alias ' + sAlias);
  Exit;
 end;

end;
}

 Lista  := TStringList.Create;
 Result := False;

 {To obtain those alias of the session}
 try
  Session.GetAliasNames(Lista);
 except
  Exit;
 end;

 {To look if the exists alias}
 i := 0;
 while (Length(Lista[i]) > 0) and (Lista.Count > 0) do begin
  if Lista[i] = sAlias then begin
   Result := True;
   Exit;
  end;
  if i < (Lista.Count - 1) then Inc(i) else Break;
 end;

 // To define those alias in function of the driver type
 Lista.Clear;
 sType := UpperCase(sType);
 if (sType = 'DBASE') or (sType = 'PARADOX') then begin
  Lista.Add('DEFAULT DRIVER=' + sType);

  if sType = 'PARADOX' then Lista.Add('ENABLE BCD=FALSE');
  sType := 'STANDARD';

  if sPath[Length(sPath)] = '\' then sPath := Copy(sPath,1,Length(sPath)-1);
  Lista.Add('PATH=' + sPath);
 end;

 if sType = 'MSACCESS' then begin
  Lista.Add('DATABASE NAME=' + sPath + sAlias + '.Mdb');
  Lista.Add('LANG DRIVER='+ DbLangGeneral); // DbLangGeneral
  Lista.Add('OPEN MODE=READ/WRITE');
  Lista.Add('SYSTEM DATABASE=');
  Lista.Add('USER NAME=');

  // If it does not exist the file .mdb, we create it with DAO
  if not FileExists(sPath + sAlias + '.mdb') then begin

   if not GetEngine(DbEngine) then Exit;

   try
    DbAccess := DbEngine.WorkSpaces[0];
    // Create .mdb DataBase with DAO
    DbTable := DbAccess.CreateDatabase(sPath + sAlias + '.mdb',
                                       DbLangGeneral,
                                       DbVersion30);
    DbAccess.Close;
   except
    ShowMessage('Cannot create DataBase with Dao ' + #13 +
                sPath + sAlias + '.mdb');
   end;
  end;
  // Once has created the file .mdb and the Bde Alias, it can create tables as
  // if it would be a driver standard as dBase or Paradox, with standar component
 end;

  // To create the new alias into BDE
 fConfigMode := Session.ConfigMode;
 try
  DbiInit(nil);
  Session.AddAlias(sAlias, sType, Lista);
  Session.SaveConfigFile;
 except
  Session.ConfigMode := fConfigMode;
  Exit;
 end;
 Result := True;
 ShowMessage('(c) Sigecom' + #13 +
             'http://www.arrakis.es/~sigecom' + #13 +  #13 +
             'New MsAccess Alias : ' + sAlias);
end;

procedure NewTable(var Table1: TTable);
begin
 // Posibol Fields in en dBase
 with Table1 do begin
  Close;
  TableType    := ttDefault;
  with FieldDefs do
   begin
   Clear;
   // Support in dBase and MsAccess 97
   Add('cString',      ftString,      35, False);
   Add('cSmallint',    ftSmallint,     0, False);
   Add('cInteger',     ftInteger,      0, False);
   Add('cWord',        ftWord,         0, False);
   Add('cFloat',       ftFloat,        0, False);
   Add('cCurrency',    ftCurrency,     0, False);
   Add('cBoolean',     ftBoolean,      0, False);
   Add('cBCD',         ftBcd,          0, False);
   Add('cTime',        ftTime,         0, False);
   Add('cDate',        ftDate,         0, False);
   Add('cDateTime',    ftDateTime,     0, False);
   Add('cAutoInc',     ftAutoInc,      0, False);
   Add('cBlob',        ftBlob,         0, False);
   Add('cGraphic',     ftGraphic,      0, False);
   Add('cMemo',        ftMemo,         0, False);
   Add('cFmtMemo',     ftFmtMemo,      0, False);
   Add('cFixedChar',   ftFixedChar,   10, False);
   Add('cWideString',  ftWideString,  10, False);

// Not supported in dBase
//   Add('cBytes',       ftBytes,        0, False);
//   Add('cVarBytes',    ftVarBytes,     0, False);
//   Add('cCursor',      ftCursor,       0, False);
//   Add('cLargeint',    ftLargeint,     0, False);
//   Add('cADT',         ftADT,          0, False);
//   Add('cArray',       ftArray,        0, False);
//   Add('cReference',   ftReference,    0, False);
//   Add('cDataSet',     ftDataSet,      0, False);

  end;
  with IndexDefs do begin
   Clear;
  end;
  CreateTable;
 end;
end;

procedure CreateExampleTable(var Table1: TTable);
var
 i: Integer;
begin
 // To create tables to use in the example
 if not TestAlias('AccessDao', 'MSACCESS', Dir) then begin
  ShowMessage('Cannot create the Alias ' + 'AccessDao');
  Exit;
 end;

 // Create TmpTable for append in AccessDao.Mdb
 if not FileExists(Dir + 'AccessDao.Dbf') then begin
  with Table1 do begin
   Close;
   DataBaseName := Dir;
   TableName    := 'AccessDao.Dbf';
   NewTable(Table1);
   Open;
   Append;
   FieldByName('cString').AsString := 'Fields compatible dBase - MsAccess';
   Post;
   Close;
  end;
 end;

 if not FileExists(Dir + 'AccessDao.Mdb') then begin
  AppendTableDao(Table1,Dir + 'AccessDao.Mdb','AccessDao',True);
  DeleteFile(Dir + 'AccessDao.Dbf');
 end;

 // Create example Table of dBase
 if not FileExists(Dir + 'DbfExample.Dbf') then begin
  with Table1 do begin
   Close;
   DataBaseName := Dir;
   TableName    := 'DbfExample.Dbf';
   with FieldDefs do begin
    Clear;
    Add('Text',      ftString,      20, False);
    Add('Valor',     ftInteger,      0, False);
   end;
   CreateTable;
   Open;
   for i := 1 to 10 do begin
    Append;
    FieldByName('Text').AsString   := 'Table .dbf Field ' + IntToStr(i);
    FieldByName('Valor').AsInteger := i;
    Post;
   end;
  end;
 end;

 // Create example Table of Paradox
 if not FileExists(Dir + 'ParadoxExample.Db') then begin
  with Table1 do begin
   Close;
   DataBaseName := Dir;
   TableName    := 'ParadoxExample.Db';
   with FieldDefs do begin
    Clear;
    Add('Text',      ftString,      20, False);
    Add('Valor',     ftInteger,      0, False);
   end;
   CreateTable;
   Open;
   for i := 1 to 10 do begin
    Append;
    FieldByName('Text').AsString   := 'Table .db Field ' + IntToStr(i);
    FieldByName('Valor').AsInteger := i;
    Post;
   end;
  end;
 end;
end;

function AppendTableDao(var Table1: TTable;
                        DbAccessName,TbAccessName: String;
                        OverWrite: Boolean): Integer;
var
 DbEngine,DbAccess,DbDataBase,DbTable : Variant;
 i: Integer;
 Exists: Boolean;
begin

 Result := 0; // Records append
 TimeStart := Now;
 Exists := False;
 // To verify the extension of the new table
 if Pos( '.MDB', UpperCase(DbAccessName)) = 0 then Exit;

 if not GetEngine(DbEngine) then Exit;

 try
  DbAccess := DbEngine.WorkSpaces[0];
  if not FileExists(DbAccessName) then begin // The file .mdb of Access doesn't exist
   // To create the database Access
   DbDataBase := DbAccess.CreateDatabase(DbAccessName,DbLangGeneral,DbVersion30);
   // To create the object Table
   DbTable := DbDataBase.CreateTableDef(TbAccessName);
   // To create the Table
   CreateAccessFields(Table1,DbDataBase,DbTable);
  end else begin // The file .mdb of Access exists
   // To create the database Access
   DbDataBase := DbAccess.OpenDataBase(DbAccessName,,False,);
   for i := 0 to DbDataBase.TableDefs.Count - 1 do // To look if the table exists
    if DbDataBase.TableDefs[i].Name = TbAccessName then Exists := True;

   if not Exists then begin // The table doesn't exist and we believe it
    DbTable := DbDataBase.CreateTableDef(TbAccessName);
    // To create the fields
    CreateAccessFields(Table1,DbDataBase,DbTable);
   end else begin // The table exists
    if OverWrite
     then
      begin // Overwrite
       DbDataBase.TableDefs.Delete(TbAccessName);
       DbTable := DbDataBase.CreateTableDef(TbAccessName);
       CreateAccessFields(Table1,DbDataBase,DbTable);
      end
     else // Not overwrite
      DbTable := DbDataBase.CreateTableDef(TbAccessName);
   end;
  end;

  // Open the table
  DbTable := DbDataBase.OpenRecordSet(TbAccessName,dbOpenTable);

  // Append the table
  Result := CopyToAccess(Table1, DbTable); // Record append
 finally
  DbAccess.Close;
 end;

 Screen.Cursor := crDefault;
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 ShowSigecom('Record append : ' + IntToStr(Result));
end;

function AppendTableBde(var TableSource, TableAccess: TTable; OverWrite: Boolean): Integer;
var
 i: Integer;
begin
 Result := 0;
 TimeStart := Now;
 TableSource.Open;
 with TableAccess do begin
  Close;
  if OverWrite then begin
   with FieldDefs do begin
    Clear;
    for i := 0 to TableSource.FieldCount -1 do
     Add(TableSource.FieldDefs.Items[i].Name,
         TableSource.FieldDefs.Items[i].DataType,
         TableSource.FieldDefs.Items[i].Size,
         False);
   end;
   CreateTable;
   Open;
  end;
 end;

 with TableSource do begin
  if not Active then Open;
  while not Eof do begin
   TableAccess.Append;
   for i := 0 to FieldCount -1 do TableAccess.Fields[i].Assign(Fields[i]);
   TableAccess.Post;
   Inc(Result);
   Next;
  end;
 end;

 Screen.Cursor := crDefault;
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 ShowSigecom('Record append : ' + IntToStr(Result));
end;

function QueryBDE(var Query1: TQuery; Alias,SqlFilter: String): Integer;
begin
 Result := 0;
 TimeStart := Now;
 if (Alias = '') or (SqlFilter = '') then Exit;
 with Query1 do begin
  // Config the query
  if Active then Close;
  DataBaseName := Alias;
  SQL.clear;
  SQL.Add(SqlFilter);
  try
   Active := True; // To execute the query
  finally
   if Active then Result := RecordCount; // Query  executed
   Screen.Cursor := crDefault;
  end;
 end;
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 ShowSigecom('Record filter : ' + IntToStr(Result));
end;

function QueryDao(var DataBase1: TDataBase; var TableSource, TableQuery: TTable;
                  DbAccessName,TbAccessName,SqlFilter: String): Integer;
var
 DbEngine,DbAccess,DbDataBase,DbTable : Variant;
 i,k: Integer;
 Exists: Boolean;
 bSource: Boolean;
 sNameTableSource: String;
begin
 // This function returns in the table TableQuery the registrations that
 // complete the condition demanded SQL

 Result  := 0; // Records append
 // To verify the extension of the new table
 if Pos( '.MDB', UpperCase(DbAccessName)) = 0 then Exit;

 if not FileExists(DbAccessName) then Exit; // The file .mdb of Access doesn't exist

 TimeStart := Now;
 Exists    := False;
 bSource   := False;

 with TableQuery do begin
  Close;
  DataBaseName := ExtractFilePath(Application.ExeName);
  TableName    := 'TmpAccessDao.Dbf';
 end;

 try
  DbEngine := CreateOleObject('Dao.DbEngine.35');
  DbAccess := DbEngine.WorkSpaces[0];
  // To create the database Access
  DbDataBase := DbAccess.OpenDataBase(DbAccessName,,False,);
  for i := 0 to DbDataBase.TableDefs.Count - 1 do // To look if the table exists
   if DbDataBase.TableDefs[i].Name = TbAccessName
    then begin
     Exists := True;
     Break;
    end;

  if not Exists then Exit; // The table doesn't exist
  DbTable := DbDataBase.OpenRecordset(SqlFilter,dbOpenDynaSet);
  k := 0;
  if DbTable.RecordCount > 0 then begin // Initially it always returns value 1
   // To prepare the table with the data of the query
   bSource := TableSource.Active;
   if not TableSource.Active then TableSource.Open;
   sNameTableSource := TableSource.TableName;
   with TableQuery do begin
    with FieldDefs do begin
     Clear;
     for i := 0 to TableSource.FieldCount -1 do
      Add(TableSource.FieldDefs.Items[i].Name,
          TableSource.FieldDefs.Items[i].DataType,
          TableSource.FieldDefs.Items[i].Size,
          False);
    end;
    CreateTable;
    Open;

    DbTable.MoveFirst;

    while not DbTable.Eof do begin
     Append;
     for i := 0 to FieldCount -1 do begin
      if FieldDefs.Items[i].DataType in [ftString, ftBytes, ftVarBytes, ftWideString,
                                         ftBytes,ftVarBytes,ftMemo, ftFmtMemo,ftWideString]
       then try
             // If the field is empty, return error when delphi is running
             Fields[i].Text := DbTable.Fields[i];
            except
            end;
      if FieldDefs.Items[i].DataType in [ftSmallint,ftInteger,ftWord,ftLargeInt,
                                         ftFloat,ftCurrency,ftBoolean,ftDate,
                                         ftTime,ftDateTime,ftParadoxOle,ftDBaseOle,
                                         ftAutoInc,ftCursor,ftADT,ftArray,ftReference,
                                         ftDataSet]
       then try
             Fields[i].Value := DbTable.Fields[i].Value;
            except
            end;
     end;
     Post;
     Inc(k);
     DbTable.MoveNext;
    end;
   end;
   Result := k;
  end;
 finally
  DbAccess.Close;
  TableSource.Active := bSource; // It returns the active state from the table to their initial situation
  TableQuery.Close; // Save Changes to HD in dBase
  TableQuery.Open;

 ConfigDataBase(DataBase1,False);
  with TableSource do begin
   Close;
   DataBaseName := sAlias;
   TableName    := sNameTableSource;
   try
    Open;
   except
   end;
  end;

 end;
 Screen.Cursor := crDefault;
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 ShowSigecom('Record append : ' + IntToStr(Result));

end;

function CompactDataBaseDao(DbAccessName: String): Boolean;
var
 DbEngine: Variant;
 TmpFile: String;
begin

 Result := False; // Records append
 TimeStart := Now;
 if Dir = '' then Exit;
 TmpFile := Dir + 'TmpAccess.Mdb';
 // To verify the extension of the new table
 if Pos( '.MDB', UpperCase(DbAccessName)) = 0 then Exit;

 // Check if exists the file .mdb of Access
 if not FileExists(DbAccessName) then Exit;

 try
  if not GetEngine(DbEngine) then Exit;
  if FileExists(TmpFile) then DeleteFile(TmpFile);
  DbEngine.CompactDataBase(DbAccessName,TmpFile);
  DeleteFile(DbAccessName);
  RenameFile(TmpFile,DbAccessName);
  Result := True;
 except
  Screen.Cursor := crDefault;
  Exit;
 end;
 Screen.Cursor := crDefault;
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 if Result then ShowSigecom('DataBase ' + DbAccessName + ' compact');

end;

function RepairDataBaseDao(DbAccessName: String): Boolean;
var
 DbEngine: Variant;
begin

 Result := False; // Records append
 TimeStart := Now;
 if Dir = '' then Exit;

 // Check if exists the file .mdb of Access
 if not FileExists(DbAccessName) then Exit;

 try
  if not GetEngine(DbEngine) then Exit;
  DbEngine.RepairDataBase(DbAccessName);
  Result := True;
 except
  Screen.Cursor := crDefault;
  Exit;
 end;
 Screen.Cursor := crDefault;
 if Result then ShowSigecom('DataBase ' + DbAccessName + ' repaired');
end;

procedure ShowSigecom(Text: String);
begin
 DecodeTime(Now - TimeStart,Hour,Min,Sec,MSec);  // To put the hour bis miliseconds
 ShowMessage('(c) Sigecom  -  http://www.arrakis.es/~sigecom' + #13 +  #13 + Text + #13 +
             'Time : ' + IntToStr(Hour) + ':' + IntToStr(Min) + ':' +
                         IntToStr(Sec)  + ':' + IntToStr(MSec));
end;

procedure InfoIndex(Table1: TTable; sIndexName: String; var IndexInfo: TComboBox);
 function BoolVal(InBool: Boolean): String;
  begin
    if InBool = True then Result:= 'True'
    else Result:= 'False';
  end;
var
 IndexDesc : IDXDesc;
 KeyArray  : String;
 x         : Integer;
 bActive   : Boolean;
 sIndex    : String;
begin
 IndexInfo.Text := '';
 {To obtain the data related to each one from the index}
 try
  bActive := Table1.Active;
  sIndex  := Table1.IndexName;
  if not Table1.Active then Table1.Open;
  Table1.IndexName := sIndexName;
  DbiGetIndexDesc(Table1.Handle,0,IndexDesc);
  IndexInfo.Clear;
  with IndexInfo.Items do begin
   Add('Key Expression : ' + IndexDesc.szKeyExp);
   Add('Index Name : ' + IndexDesc.szname);
   Add('Tag Name (dBASE) : ' + IndexDesc.szTagName);
   Add('Index Format : ' + IndexDesc.szformat);
   Add('Primary : ' + BoolVal(IndexDesc.bPrimary));
   Add('Descending : ' + BoolVal(IndexDesc.bDescending));
   Add('Maintained : ' + BoolVal(IndexDesc.bMaintained));
   Add('Subset : ' + BoolVal(IndexDesc.bSubset));
   Add('ExpIdx : ' + BoolVal(IndexDesc.bExpIdx));
   Add('Fields In Key : ' + IntToStr(IndexDesc.iFldsInKey));
   Add('Key Length : ' + IntToStr(IndexDesc.iKeyLen));
   Add('Out of Date : ' + BoolVal(IndexDesc.bOutofDate));
   Add('Key Expression Type : ' + IntToStr(IndexDesc.iKeyExpType));
   KeyArray := '';
   for x:= 0 to IndexDesc.iFldsInKey -1 do
    KeyArray := KeyArray + IntToStr(IndexDesc.aiKeyFld[x]) + ', ';
   Add('Field Numbers used in Key : ' + KeyArray);
   Add('Key Condition : ' + IndexDesc.szKeyCond);
   Add('Case Insensitive : ' + BoolVal(IndexDesc.bCaseInsensitive));
   Add('iBlockSize : ' + IntToStr(IndexDesc.iBlockSize));
   Add('iRestrNum : ' + IntToStr(IndexDesc.iRestrNum));
   IndexInfo.Text := 'Key Expression : ' + IndexDesc.szKeyExp;
  end;
 finally
  Table1.IndexName := sIndex;
  Table1.Active    := bActive;
 end;
end;

end.
